#IF 0
  =============================================================================
   Program name: 
   Author      : Eros Olmi
   Date        : 
   Version     : 
   Description : 
  =============================================================================
  =============================================================================
#ENDIF

  #COMPILE DLL
  #REGISTER NONE
  #DIM ALL

  Global gPath      As String     '---Path from where this DLL has been loaded

  Global gToken     As Dword
  Global GDI_Loaded As Long
  
  #Resource "thinBasic_GDIP.PBR"
  
  #Include "WIN32API.INC"
  #Include ".\thinCore.INC"       '---Headers for thinBasic SDK
  #Include ".\thinBasic_GDIP.Inc"
  '------------------------------------------------------------------
  '------------------------------------------------------------------

  '------------------------------------------------------------------
  ' Load GDI+
  '------------------------------------------------------------------
  FUNCTION thinBasic_LoadLib() AS LONG
  '------------------------------------------------------------------

    '---Initialize GDI+
    local hr as long
    local StartupInput as GdiplusStartupInput

    StartupInput.GdiplusVersion = 1
    hr = GdiplusStartup(gToken, StartupInput, byval %null)
    if hr then
      GDI_Loaded = %FALSE
      function = 0&
    else
      GDI_Loaded = %TRUE
      function = gToken
    end if
    
  END FUNCTION

  '----------------------------------------------------------------------------
  function Exec_GDIP_LoadImageFromFile() as ext
  '----------------------------------------------------------------------------
  ' 
  '----------------------------------------------------------------------------
    local hStatus       as long
    local pImage        as dword
    local strFileName   as string
    Local pp            As Long
    
    pp = thinBasic_CheckOpenParens_Optional
    thinBasic_ParseString strFileName
    If pp Then thinBasic_CheckCloseParens_Mandatory

    If thinBasic_ErrorFree Then
    
      '---Name here is UNICODE  
      strFileName = strFileName & $nul
      strFileName = ucode$(strFileName)
      hStatus = GdipLoadImageFromFile(strFileName, pImage)
      Function = pImage
        
    end if 
     
  end function

  '----------------------------------------------------------------------------
  function Exec_GDIP_CreateBitMapFromFile() as ext
  '----------------------------------------------------------------------------
  ' Create a hGpBitmap object from an image file
  '----------------------------------------------------------------------------
    Local hStatus       As Long
    local hGpBitmap     as dword
    Local strFileName   As String
    Local pp            As Long
    
    pp = thinBasic_CheckOpenParens_Optional
    thinBasic_ParseString strFileName
    If pp Then thinBasic_CheckCloseParens_Mandatory

    If thinBasic_ErrorFree Then
        '---Name here is UNICODE  
        strFileName = strFileName & $Nul
        strFileName = UCode$(strFileName)
        hStatus = GdipCreateBitmapFromFile(strFileName, hGpBitmap)
        function = hGpBitmap
        
    End If 
     
  End Function

  '----------------------------------------------------------------------------
  function Exec_GDIP_HBitMapFromBitmap() as ext
  '----------------------------------------------------------------------------
  ' Creates a hBitmap from a GpBitmap
  '----------------------------------------------------------------------------
    Local hStatus       As Long
    local hGpBitmap     as ext
    Local hBitmap       As Dword
    
    hGpBitmap = thinBasic_Parse1Number
    GdipCreateHBITMAPFromBitmap(hGpBitmap, hBitmap, 0)
    function = hBitmap
        
  End Function

  '----------------------------------------------------------------------------
  function Exec_GDIP_DisposeImage() as ext
  '----------------------------------------------------------------------------
  '
  '----------------------------------------------------------------------------
  
    local pImage       as ext
    
    pImage = thinBasic_Parse1Number
    if pImage then GdipDisposeImage(pImage)
    
  End Function

  '----------------------------------------------------------------------------
  '
  '----------------------------------------------------------------------------
  function Exec_GDIP_DeleteGraphics() as ext
  '----------------------------------------------------------------------------
  
    local pGraphics       as ext
    
    pGraphics = thinBasic_Parse1Number
    if pGraphics then GdipDeleteGraphics(pGraphics)
    
  end function


  '----------------------------------------------------------------------------
  '
  '----------------------------------------------------------------------------
  function Exec_GDIP_GetImageSizeFromFile() as ext
  '----------------------------------------------------------------------------
    local strFileName       as string
    local nWidth            as dword
    local nHeight           as dword

    local lVariablePtr1     as long
    local lVariableAbsPos1  as long
    local lVariablePtr2     as long
    local lVariableAbsPos2  as long
    
    Local pp            As Long
    
    pp = thinBasic_CheckOpenParens_Optional

    thinBasic_ParseString strFileName
    if thinBasic_CheckComma_Mandatory then
      thinBasic_VariableParse(lVariablePtr1, lVariableAbsPos1)
      if thinBasic_ErrorFree then
        if thinBasic_CheckComma_Mandatory then
          thinBasic_VariableParse(lVariablePtr2, lVariableAbsPos2)
        End If
      End If
    End If
          
    If pp Then thinBasic_CheckCloseParens_Mandatory

    If thinBasic_ErrorFree Then
      '---Name here is ANSI
      GdiPlusGetImageSizeFromFile(strFileName, nWidth, nHeight)
      
      thinBasic_ChangeVariableNumberDirect (lVariablePtr1, lVariableAbsPos1, nWidth)
      thinBasic_ChangeVariableNumberDirect (lVariablePtr2, lVariableAbsPos2, nHeight)

    end if          

  end function

  '----------------------------------------------------------------------------
  ' Returns Width in pixel of a 
  '----------------------------------------------------------------------------
  function Exec_GDIP_GetImageWidth() as ext
  '----------------------------------------------------------------------------
    local hGpBitmap as ext
    local nWidth    as dword

    hGpBitmap = thinBasic_Parse1Number
    if hGpBitmap then
      GdipGetImageWidth(hGpBitmap, nWidth)
      function = nWidth
    end if
    
  end function

  '----------------------------------------------------------------------------
  ' Returns Width in pixel of a 
  '----------------------------------------------------------------------------
  function Exec_GDIP_GetImageHeight() as ext
  '----------------------------------------------------------------------------
    local hGpBitmap as ext
    local nHeight   as dword

    hGpBitmap = thinBasic_Parse1Number
    if hGpBitmap then
      GdipGetImageHeight(hGpBitmap, nHeight)
      function = nHeight
    end if
    
  end function


  '----------------------------------------------------------------------------
  function Exec_GDIP_ConvertImage() as ext
  '----------------------------------------------------------------------------
  ' Syntax: GDIp_ConvertImage(SourceFile, DestinationFile, MimeType)
  '----------------------------------------------------------------------------
    Local hStatus       As Long
    Local LoadFileName  As String
    Local SaveFileName  As String
    Local MimeType      As String   ' "image/tiff"
    Local pp            As Long
    
    pp = thinBasic_CheckOpenParens_Optional

    thinBasic_ParseString LoadFileName
    If thinBasic_CheckComma_Mandatory Then
      thinBasic_ParseString SaveFileName
      if thinBasic_CheckComma_Mandatory then
        thinBasic_ParseString MimeType
      End If
    End If
    
    If pp Then thinBasic_CheckCloseParens_Mandatory

    If thinBasic_ErrorFree Then
      Function = GdiPlusConvertImage (LoadFileName, SaveFileName, MimeType)
    end if 
     
  end function

  '----------------------------------------------------------------------------
  function Exec_GDIP_SaveImageToFile() as ext
  '----------------------------------------------------------------------------
  ' Syntax: 
  '----------------------------------------------------------------------------
    Local hStatus       As Long
    Local pImage        As Ext
    Local SaveFileName  As String
    Local MimeType      As String   ' example "image/tiff"
    Local pp            As Long
    
    pp = thinBasic_CheckOpenParens_Optional
    thinBasic_ParseNumber pImage
    if thinBasic_CheckComma_Mandatory then
      thinBasic_ParseString SaveFileName
      if thinBasic_CheckComma_Mandatory then
        thinBasic_ParseString MimeType
      End If
    End If
    
    If pp Then thinBasic_CheckCloseParens_Mandatory

    If thinBasic_ErrorFree Then

      Function = GdiPlusSaveImageToFile (pImage, SaveFileName, MimeType)

    end if 
     
  end function

  '----------------------------------------------------------------------------
  function Exec_GDIP_GetImageThumbnail() as ext
  '----------------------------------------------------------------------------
  ' Syntax: 
  '----------------------------------------------------------------------------
    Local hStatus       As Long
    Local pImage        As Ext
    Local x             As Ext
    Local y             As Ext
    Local pThumbnail    As Dword
    Local pp            As Long
    
    pp = thinBasic_CheckOpenParens_Optional
    thinBasic_ParseNumber pImage
    if thinBasic_CheckComma_Mandatory then
      thinBasic_ParseNumber x
      if thinBasic_CheckComma_Mandatory then
        thinBasic_ParseNumber y
      End If
    End If
    
    If pp Then thinBasic_CheckCloseParens_Mandatory

    If thinBasic_ErrorFree Then

      hStatus = GdipGetImageThumbnail(pImage, x, y, pThumbnail, %null, %null)
      Function = pThumbnail
            
    end if 
     
  end function

  '----------------------------------------------------------------------------
  function Exec_GDIP_CreateFromHDC() as ext
  '----------------------------------------------------------------------------
  ' Syntax: 
  '----------------------------------------------------------------------------
    Local hDC           As Ext
    Local pGraphics     As Dword

    hDC = thinBasic_Parse1Number
    if hDC then
      GdipCreateFromHDC(hdc, pGraphics)
      function = pGraphics
    end if
    
  end function

  '----------------------------------------------------------------------------
  function Exec_GDIP_DrawImage() as ext
  '----------------------------------------------------------------------------
  ' Syntax: 
  '----------------------------------------------------------------------------
    Local pGraphics     As Ext
    Local pImage        As Ext
    Local x             As Ext
    Local y             As Ext
    Local pp            As Long
    
    pp = thinBasic_CheckOpenParens_Optional
    thinBasic_ParseNumber pGraphics
    if thinBasic_CheckComma_Mandatory then
      thinBasic_ParseNumber pImage
      if thinBasic_CheckComma_Mandatory then
        thinBasic_ParseNumber x
        if thinBasic_CheckComma_Mandatory then
          thinBasic_ParseNumber y
        End If
      End If
    End If
    
    If pp Then thinBasic_CheckCloseParens_Mandatory

    If thinBasic_ErrorFree Then
  
      Function = GdipDrawImage(pGraphics, pImage, x, y)
              
    end if 
     
  end function

  '----------------------------------------------------------------------------
  FUNCTION LoadLocalSymbols ALIAS "LoadLocalSymbols" (OPTIONAL BYVAL sPath AS STRING) EXPORT AS LONG
  ' This function is automatically called by thinCore whenever this DLL is loaded.
  ' This function MUST be present in every external DLL you want to use
  ' with thinBasic
  ' Use this function to initialize every variable you need and for loading the
  ' new symbol (read Keyword) you have created.
  '----------------------------------------------------------------------------

    '---Save DLL loading path to global var
    gPath = sPath
    
    '---Load external library
    thinBasic_LoadLib
    

    if GDI_Loaded = %TRUE then

  
      thinBasic_LoadSymbol "GDIp_LoadImageFromFile"     , %thinBasic_ReturnNumber , codeptr(Exec_GDIP_LoadImageFromFile       ),  %thinBasic_ForceOverWrite
      thinBasic_LoadSymbol "GDIp_CreateBitMapFromFile"  , %thinBasic_ReturnNumber , codeptr(Exec_GDIP_CreateBitMapFromFile    ),  %thinBasic_ForceOverWrite
      thinBasic_LoadSymbol "GDIp_HBitMapFromBitmap"     , %thinBasic_ReturnNumber , codeptr(Exec_GDIP_HBitMapFromBitmap       ),  %thinBasic_ForceOverWrite
      thinBasic_LoadSymbol "GDIp_DisposeImage"          , %thinBasic_ReturnNumber , codeptr(Exec_GDIP_DisposeImage            ),  %thinBasic_ForceOverWrite
      thinBasic_LoadSymbol "GDIp_DeleteGraphics"        , %thinBasic_ReturnNumber , codeptr(Exec_GDIP_DeleteGraphics          ),  %thinBasic_ForceOverWrite


      thinBasic_LoadSymbol "GDIp_GetImageSizeFromFile"  , %thinBasic_ReturnNumber , codeptr(Exec_GDIP_GetImageSizeFromFile    ),  %thinBasic_ForceOverWrite
      thinBasic_LoadSymbol "GDIP_GetImageWidth"         , %thinBasic_ReturnNumber , codeptr(Exec_GDIP_GetImageWidth           ),  %thinBasic_ForceOverWrite
      thinBasic_LoadSymbol "GDIP_GetImageHeight"        , %thinBasic_ReturnNumber , codeptr(Exec_GDIP_GetImageHeight          ),  %thinBasic_ForceOverWrite

      thinBasic_LoadSymbol "GDIp_ConvertImage"          , %thinBasic_ReturnNumber , codeptr(Exec_GDIP_ConvertImage            ),  %thinBasic_ForceOverWrite
      thinBasic_LoadSymbol "GDIp_SaveImageToFile"       , %thinBasic_ReturnNumber , codeptr(Exec_GDIP_SaveImageToFile         ),  %thinBasic_ForceOverWrite

      thinBasic_LoadSymbol "GDIp_GetImageThumbnail"     , %thinBasic_ReturnNumber , codeptr(Exec_GDIP_GetImageThumbnail       ),  %thinBasic_ForceOverWrite
      thinBasic_LoadSymbol "GDIp_CreateFromHDC"         , %thinBasic_ReturnNumber , codeptr(Exec_GDIP_CreateFromHDC           ),  %thinBasic_ForceOverWrite

      thinBasic_LoadSymbol "GDIp_DrawImage"             , %thinBasic_ReturnNumber , codeptr(Exec_GDIP_DrawImage               ),  %thinBasic_ForceOverWrite
       
      function = 0&
  
    end if
    
  END FUNCTION

  '----------------------------------------------------------------------------
  FUNCTION UnLoadLocalSymbols ALIAS "UnLoadLocalSymbols" () EXPORT AS LONG
  ' This function is automatically called by thinCore whenever this DLL is unloaded.
  ' This function CAN be present but it is not necessary.
  ' Use this function to perform uninitialize process, if needed.
  '----------------------------------------------------------------------------

    '---Shutdown GDI+
    GdiplusShutdown gToken
    
    FUNCTION = 0&

  end function


  '----------------------------------------------------------------------------
  Function LibMain Alias "LibMain" (ByVal hInstance   As Long, _
                                    BYVAL fwdReason   AS LONG, _
                                    BYVAL lpvReserved AS LONG) EXPORT AS LONG
  '----------------------------------------------------------------------------
    Select Case fwdReason
      CASE %DLL_PROCESS_ATTACH

        FUNCTION = 1
        EXIT FUNCTION
      CASE %DLL_PROCESS_DETACH

        FUNCTION = 1
        EXIT FUNCTION
      CASE %DLL_THREAD_ATTACH
      
        FUNCTION = 1
        EXIT FUNCTION
      CASE %DLL_THREAD_DETACH
      
        FUNCTION = 1
        EXIT FUNCTION
    END SELECT 
    
  end function
  
